<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         modify_category.php
Description:  Administrative module to unlock/lock/delete a category

*/

    include "../modules/class_category.php";
    include "../modules/class_translation.php";
    include "../modules/mod_config.php";
    include "../modules/mod_admin.php";

    $bCategoryLoadFailed = false;
    $catId = "";
    $errorString = "";
    
    // Check privileges
    check_login();
    if (user_is_customer() == true)
    {
        log_out();
        return;
    }

    // Get action
    $catModAction = "unlock";
    if (isset ($_POST['cat_action']) == true)
    {
        if ($_POST['cat_action'] == "lock")
            $catModAction = "lock";
        else if ($_POST['cat_action'] == "delete")
            $catModAction = "delete";
    }
    else if (isset ($_GET['action']) == true)
    {
        if ($_GET['action'] == "lock")
            $catModAction = "lock";
        else if ($_GET['action'] == "delete")
            $catModAction = "delete";
    }

    $catCategory = new cCategory;
    $catCategory->SetFolder($CATEGORY_FOLDER);

    if (isset ($_POST['cat_id']) == true)
        $catId = $_POST['cat_id'];
    else if (isset ($_GET['id']) == true)
        $catId = $_GET['id'];

    if ($catCategory->LoadCategoryFromId($catId) == false)
    {
        print_error_message($cTrans->GetTranslation('admin_catmod_errorload') . ', ID: ' . $catId . '!!');
        $bCategoryLoadFailed = true;
    }

    // Cancel modification?
    if (isset ($_POST['cat_Cancel']))
    {
        header('location: ' . $ADMIN_CATLIST_SITE);
        return;
    }
    // Modify category?
    if (isset ($_POST['cat_DoAction']) && $bCategoryLoadFailed == false)
    {
        if ($catModAction == "lock")
        {
            if ($catCategory->SetLocked(true) == false)
                $errorString = $cTrans->GetTranslation('admin_catmod_errorlock') . ', ID: ' . $catId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' locked category ' . $catCategory->GetId());
                header('location: ' . $ADMIN_CATLIST_SITE);
                return;
            }
        }
        else if ($catModAction == "delete")
        {
            $bDone = $catCategory->DeleteCategoryFinal();  // Categories can be unlinked
            if ($bDone == false)
                $errorString = $cTrans->GetTranslation('admin_catmod_errordelete') . ', ID: ' . $catId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' deleted category ' . $catCategory->GetId());
                header('location: ' . $ADMIN_CATLIST_SITE);
                return;
            }
        }
        else
        {
            if ($catCategory->SetLocked(false) == false)
                $errorString = $cTrans->GetTranslation('admin_catmod_errorunlock') . ', ID: ' . $catId . '!!';
            else
            {
                log_message ('User ' . get_user_name() . ' unlocked category ' . $catCategory->GetId());
                header('location: ' . $ADMIN_CATLIST_SITE);
                return;
            }
        }
    }

    // Display
    $titleString = $cTrans->GetTranslation('admin_catmod_unlockhead');
    if ($catModAction == "lock")
        $titleString = $cTrans->GetTranslation('admin_catmod_lockhead');
    else if ($catModAction == "delete")
        $titleString = $cTrans->GetTranslation('admin_catmod_deletehead');
    print_admin_header($titleString, true, $cTrans->GetTranslation('admin_login_logout'), true, $cTrans->GetTranslation('admin_backtomain'),
                       $ADMIN_CATLIST_SITE, $cTrans->GetTranslation('admin_catl_button'));

    if ($errorString != "")
        print_error_message($errorString);
        
    if ($catModAction == "lock")
        echo_r('<p>' . $cTrans->GetTranslation('admin_catmod_questlock') . ':</p><br>');
    else if ($catModAction == "delete")
        echo_r('<p>' . $cTrans->GetTranslation('admin_catmod_questdelete') . ':</p><br>');
    else
        echo_r('<p>' . $cTrans->GetTranslation('admin_catmod_questunlock') . ':</p><br>');
    echo_r('<table width="100%" border="0">');
    echo_r('  <tr>');
    echo_r('    <td width="40%">');
    echo_r('       <img src="' . $CATEGORY_IMAGE . '" alt="">');
    echo_r('    </td>');
    echo_r('    <td width="60%">');
    echo_r('       ' . $cTrans->GetTranslation('admin_cat_id') . ': ' . $catCategory->GetId() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_cat_date') . ': ' . $catCategory->GetDate() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_cat_name') . ': ' . $catCategory->GetName() . '<br>');
    echo_r('       ' . $cTrans->GetTranslation('admin_cat_position') . ': ' . $catCategory->GetPosition() . '<br>');
    echo_r('    </td>');
    echo_r('  </tr>');
    echo_r('</table>');
    
    echo_r('<form method="post" action="">');
    print_bottom_links("cat_DoAction", $cTrans->GetTranslation('admin_yes'),
                       "cat_Cancel", $cTrans->GetTranslation('admin_cancel'), false);
    echo_r('  <input type="hidden" value="' .  $catId . '" name="cat_id">  ');
    echo_r('  <input type="hidden" value="' .  $catModAction . '" name="cat_action">  ');
    echo_r('</form>');

    print_admin_footer();
?>