<?php

/*  Alternate WebshopEngine
(C) 2009-2016 by Alternate Tools
-----------------------------------------------------

File:         class_article.php
Description:  Class cAtricle definition,
              handling of the article entities

*/

include "class_custfield.php";
include "class_storagefile.php";

if (!defined("CLASS_ARTICLE"))
{
    define ("CLASS_ARTICLE", "DEFINED");

    class cArticle extends cCustField
    {
        var $m_artId;
        var $m_artDate;
        var $m_artName;
        var $m_artCategoryId;
        var $m_artDescription;
        var $m_artVideo;
        var $m_artImgUrl;
        var $m_artImgThumbUrl;
        var $m_artImgLargeUrl;
        var $m_artPrice;
        var $m_artTags;
        var $m_artLocked;
        var $m_artViewCount;
        var $m_artOrderCount;
        var $m_artAccessDate;
        var $m_artAmount;
        var $m_artAddImgCount;
        var $m_artAddImgUrls;
        var $m_artAddImgThumbUrls;
        var $m_artAddImgLargeUrls;

        var $m_artFolder;
        
        var $m_artAmountNoLimit;

        function __construct()
        {
            $this->InitArticle();
            $this->cCustField();
        }

        function cArticle()  // PHP 4
        {
            $this->__construct();
        }
        
        function InitArticle()
        {
            $this->m_artAmountNoLimit = "unlimited";

            $this->m_artId = "0";
            $this->m_artDate = "";
            $this->m_artName = "";
            $this->m_artCategoryId = "0";
            $this->m_artDescription = "";
            $this->m_artVideo = "";
            $this->m_artImgUrl = "";
            $this->m_artImgThumbUrl = "";
            $this->m_artImgLargeUrl = "";
            $this->m_artPrice = 0.0;
            $this->m_artTags = "";
            $this->m_artLocked = "0";
            $this->m_artViewCount = 0;
            $this->m_artOrderCount = 0;
            $this->m_artAccessDate = "";
            $this->m_artAmount = $this->m_artAmountNoLimit;
            $this->m_artAddImgCount = 0;
            $this->InitAdditionalImages();

            $this->m_artFolder = "";
        }

        function InitAdditionalImages()
        {
            unset($this->m_artAddImgUrls);
            $this->m_artAddImgUrls = array();
            unset($this->m_artAddImgThumbUrls);
            $this->m_artAddImgUrls = array();
            unset($this->m_artAddImgLargeUrls);
            $this->m_artAddImgLargeUrls = array();
            for ($i = 0; $i < $this->m_artAddImgCount; $i ++)
            {
                $this->m_artAddImgUrls[] = "";
                $this->m_artAddImgThumbUrls[] = "";
                $this->m_artAddImgLargeUrls[] = "";
            }
        }

        // Getter and setter
        
        function GetId()
        {
            return $this->m_artId;
        }

        function GetDate()
        {
            return $this->m_artDate;
        }

        function SetName($artName)
        {
            $this->m_artName = $artName;
        }
        
        function GetName()
        {
            return $this->m_artName;
        }

        function SetCategoryId($CategoryId)
        {
            $this->m_artCategoryId = $CategoryId;
        }

        function GetCategoryId()
        {
            return $this->m_artCategoryId;
        }

        function SetDescription($artDescription)
        {
            $this->m_artDescription = $artDescription;
        }

        function GetDescription()
        {
            return $this->m_artDescription;
        }

        function SetVideo($artVideo)
        {
            $this->m_artVideo = $artVideo;
        }

        function GetVideo()
        {
            return $this->m_artVideo;
        }

        function SetImgURL($artImgUrl)
        {
            $this->m_artImgUrl = $artImgUrl;
        }

        function GetImgURL()
        {
            return $this->m_artImgUrl;
        }

        function SetImgThumbUrl($artImgThumbUrl)
        {
            $this->m_artImgThumbUrl = $artImgThumbUrl;
        }

        function GetImgThumbUrl()
        {
            return $this->m_artImgThumbUrl;
        }

        function SetImgLargeUrl($artImgLargeUrl)
        {
            $this->m_artImgLargeUrl = $artImgLargeUrl;
        }

        function GetImgLargeUrl()
        {
            return $this->m_artImgLargeUrl;
        }

        function SetPrice($artPrice)
        {
            $this->m_artPrice = $artPrice;
        }

        function GetPrice()
        {
            return $this->m_artPrice;
        }

        function SetTags($artTags)
        {
            $this->m_artTags = $artTags;
        }

        function GetTags()
        {
            return $this->m_artTags;
        }

        function IsLocked()
        {
            return ($this->m_artLocked == "1");
        }

        function SetLocked($bLock)
        {
            $this->m_artLocked = "0";
            if ($bLock == true)
                $this->m_artLocked = "1";
            return $this->SaveArticle();
        }

        function GetAccessDate()
        {
            return $this->m_artAccessDate;
        }
        function SetAccessDate()
        {
            $this->m_artAccessDate = date("Y-m-d H:i:s");
        }

        function SetFolder($artFolder)
        {
            $this->m_artFolder = $artFolder;
        }

        function IncreaseViewCount($count = 1)
        {
            if ($this->m_artViewCount == "")
                $this->m_artViewCount = 0;
            $this->m_artViewCount += $count;
            $this->SetAccessDate();
            $this->SaveArticle();
        }
        function GetViewCount()
        {
            if ($this->m_artViewCount == "")
                $this->m_artViewCount = 0;
            return $this->m_artViewCount;
        }
        function IncreaseOrderCount($count = 1)
        {
            if ($this->m_artOrderCount == "")
                $this->m_artOrderCount = 0;
            $this->m_artOrderCount += $count;
            $this->SetAccessDate();
            $this->SaveArticle();
        }
        function GetOrderCount()
        {
            if ($this->m_artOrderCount == "")
                $this->m_artOrderCount = 0;
            return $this->m_artOrderCount;
        }
        function ResetCounters()
        {
            $this->m_artViewCount = 0;
            $this->m_artOrderCount = 0;
            $this->SaveArticle();
        }

        function SetArticleAmount($amount)
        {
            if ($amount > 0 || $amount == $this->m_artAmountNoLimit)
                $this->m_artAmount = $amount;
            else
                $this->m_artAmount = 0;
        }
        function SetArticleAmountUnlimited()
        {
            $this->m_artAmount = $this->m_artAmountNoLimit;
        }
        function IsArticleAmountUnlimited()
        {
            return ($this->m_artAmount == $this->m_artAmountNoLimit);
        }
        function GetArticleAmount()
        {
            return $this->m_artAmount;
        }
        function IsArticleSoldOut()
        {
            if ($this->m_artAmount == $this->m_artAmountNoLimit || $this->m_artAmount > 0)
                return false;
                
            $this->m_artAmount = 0;
            return true;
        }
        function GetUnlimitedTag()
        {
            return $this->m_artAmountNoLimit;
        }
        
        function GetAddImgCount()
        {
            return $this->m_artAddImgCount;
        }
        function SetAddImgCount($imageCount)
        {
            if ($imageCount != $this->m_artAddImgCount)
            {
                $this->m_artAddImgCount = $imageCount;
                $this->InitAdditionalImages();
            }
        }
        function SetAddImgUrl($index, $url)
        {
            if ($index > $this->m_artAddImgCount || $index < 1)
                return false;
            $this->m_artAddImgUrls[$index - 1] = $url;
            return true;
        }
        function SetAddImgThumbUrl($index, $url)
        {
            if ($index > $this->m_artAddImgCount || $index < 1)
                return false;
            $this->m_artAddImgThumbUrls[$index - 1] = $url;
            return true;
        }
        function SetAddImgLargeUrl($index, $url)
        {
            if ($index > $this->m_artAddImgCount || $index < 1)
                return false;
            $this->m_artAddImgLargeUrls[$index - 1] = $url;
            return true;
        }
        function GetAddImgUrl($index)
        {
            if ($index > $this->m_artAddImgCount || $index < 1 || isset($this->m_artAddImgUrls[$index - 1]) == false)
                return "";
            return $this->m_artAddImgUrls[$index - 1];
        }
        function GetAddImgThumbUrl($index)
        {
            if ($index > $this->m_artAddImgCount || $index < 1 || isset($this->m_artAddImgThumbUrls[$index - 1]) == false)
                return "";
            return $this->m_artAddImgThumbUrls[$index - 1];
        }
        function GetAddImgLargeUrl($index)
        {
            if ($index > $this->m_artAddImgCount || $index < 1 || isset($this->m_artAddImgLargeUrls[$index - 1]) == false)
                return "";
            return $this->m_artAddImgLargeUrls[$index - 1];
        }
        

        // Main methods
        function CreateArticle()
        {
            $this->InitArticle();
            $this->m_artId = uniqid("art", FALSE);
            $this->m_artDate = date("Y-m-d H:i:s");
        }

        function DeleteArticelFinal()
        {
            $deleteDone = true;
            if (unlink($this->m_artFolder . $this->m_artId . ".art") == false)
                $deleteDone = false;
            if (file_exists($this->m_artImgUrl) == true)  // Upload might be failed
            {
                if (unlink($this->m_artImgUrl) == false)
                    $deleteDone = false;
            }
            if (file_exists($this->m_artImgLargeUrl) == true)  // Upload might be failed
            {
                if (unlink($this->m_artImgLargeUrl) == false)
                    $deleteDone = false;
            }
            if (file_exists($this->m_artImgThumbUrl) == true)  // Upload might be failed
            {
                if (unlink($this->m_artImgThumbUrl) == false)
                    $deleteDone = false;
            }
            for ($i = 0; $i < $this->m_artAdditionalImagesCount; $i ++)
            {
                if (file_exists($this->GetAdditionalImageUrl($i)) == true)  // Upload might be failed
                {
                    if (unlink($this->GetAdditionalImageUrl($i)) == false)
                        $deleteDone = false;
                }
                if (file_exists($this->GetAdditionalImageThumbUrl($i)) == true)  // Upload might be failed
                {
                    if (unlink($this->GetAdditionalImageThumbUrl($i)) == false)
                        $deleteDone = false;
                }
                if (file_exists($this->GetAdditionalImageLargeUrl($i)) == true)  // Upload might be failed
                {
                    if (unlink($this->GetAdditionalImageLargeUrl($i)) == false)
                        $deleteDone = false;
                }
            }
            return $deleteDone;
        }

        function DeleteArticelFinalFromId($artId)
        {
            $this->m_artId = $artId;
            return DeleteArticleFinal();
        }

        function UnlockArticle()
        {
            $m_artLocked = "0";
            $this->SaveArticle();
        }

        function LockArticle()
        {
            $m_artLocked = "1";
            $this->SaveArticle();
        }

        function LoadArticleFromId($artId)
        {
            $this->m_artId = $artId;
            return $this->LoadArticle();
        }

        function LoadArticle()
        {
            $fileName = $this->m_artFolder . $this->m_artId  . ".art";
            //echo  $fileName;

            if ($this->m_artId == "0" || $this->m_artFolder == "")
                return false;

            $cStorage = new cStorageFile;
            if ($cStorage->LoadStorageFromFile($fileName) == false)
                return false;
                
            if ($cStorage->GetData("Id") == "")
                return false;

            $this->m_artId = $cStorage->GetData("Id");
            $this->m_artDate = $cStorage->GetData("Date");
            $this->m_artName = $cStorage->GetData("Name");
            if ($cStorage->GetData("CategoryId") != "")
                $this->m_artCategoryId = $cStorage->GetData("CategoryId");
            else
                $this->m_artCategoryId = "0";
            $this->m_artDescription = $cStorage->GetData("Description");
            $this->m_artVideo = $cStorage->GetData("Video");
            $this->m_artImgUrl = $cStorage->GetData("ImgUrl");
            $this->m_artImgThumbUrl = $cStorage->GetData("ThumbImgUrl");
            $this->m_artImgLargeUrl = $cStorage->GetData("LargeImgUrl");
            $this->m_artPrice = $cStorage->GetData("Price");
            $this->m_artTags = $cStorage->GetData("Tags");
            $this->m_artLocked = $cStorage->GetData("Locked");
            $this->m_artViewCount = $cStorage->GetData("ViewCount");
            $this->m_artOrderCount = $cStorage->GetData("OrderCount");
            $this->m_artAccessDate = $cStorage->GetData("AccessDate");
            if ($cStorage->GetData("ArticleAmount") != "")
                $this->m_artAmount = $cStorage->GetData("ArticleAmount");
            else
                $this->m_artAmount = $this->m_artAmountNoLimit;

            // Additional images
            $this->m_artAddImgCount = $cStorage->GetData("AddImgCount");
            if (is_numeric($this->m_artAddImgCount) == false || $this->m_artAddImgCount < 0)
                $this->m_artAddImgCount = 0;
            $this->InitAdditionalImages();
            for ($i = 1; $i <= $this->m_artAddImgCount; $i ++)
            {
                $this->SetAddImgUrl($i, $cStorage->GetData("AddImgUrl" . $i));
                $this->SetAddImgThumbUrl($i, $cStorage->GetData("AddImgThumbUrl" . $i));
                $this->SetAddImgLargeUrl($i, $cStorage->GetData("AddImgLargeUrl" . $i));
            }

            // Custom fields
            for ($i = 1; $i <= $this->GetCustFieldCount(); $i ++)
            {
                if ($cStorage->GetData("CustFieldName" . $i) != "")
                    $this->SetCustFieldName($i, $cStorage->GetData("CustFieldName" . $i));
                if ($cStorage->GetData("CustFieldValue" . $i) != "")
                    $this->SetCustFieldValue($i, $cStorage->GetData("CustFieldValue" . $i));
            }

            return true;
        }

        function SaveArticle()
        {
            $newRow = "\r\n";
            $fileName = $this->m_artFolder . $this->m_artId . ".art";
            // echo $fileName;

            if ($this->m_artId == "0" || $this->m_artFolder == "")
                return false;

            $cStorage = new cStorageFile;
            $cStorage->SetType("article");
            $cStorage->SetVersion("1.000");
            $cStorage->AddData("Id", $this->m_artId);
            $cStorage->AddData("Date", $this->m_artDate);
            $cStorage->AddData("Name", $this->m_artName);
            $cStorage->AddData("CategoryId", $this->m_artCategoryId);
            $cStorage->AddData("Description", $this->m_artDescription);
            $cStorage->AddData("Video", $this->m_artVideo);
            $cStorage->AddData("ImgUrl", $this->m_artImgUrl);
            $cStorage->AddData("ThumbImgUrl", $this->m_artImgThumbUrl);
            $cStorage->AddData("LargeImgUrl", $this->m_artImgLargeUrl);
            $cStorage->AddData("Price", $this->m_artPrice, false);
            $cStorage->AddData("Tags", $this->m_artTags);
            $cStorage->AddData("Locked", $this->m_artLocked, false);
            $cStorage->AddData("ViewCount", $this->m_artViewCount, false);
            $cStorage->AddData("OrderCount", $this->m_artOrderCount, false);
            $cStorage->AddData("AccessDate", $this->m_artAccessDate);
            $cStorage->AddData("ArticleAmount", $this->m_artAmount, false);

            // Additional images
            $cStorage->AddData("AddImgCount", $this->m_artAddImgCount, false);
            for ($i = 1; $i <= $this->m_artAddImgCount; $i ++)
            {
                $cStorage->AddData("AddImgUrl" . $i, $this->GetAddImgUrl($i));
                $cStorage->AddData("AddImgLargeUrl" . $i, $this->GetAddImgLargeUrl($i));
                $cStorage->AddData("AddImgThumbUrl" . $i, $this->GetAddImgThumbUrl($i));
            }
            // Custom fields
            for ($i = 1; $i <= $this->GetCustFieldCount(); $i ++)
            {
                $cStorage->AddData("CustFieldName" . $i, $this->GetCustFieldName($i));
                $cStorage->AddData("CustFieldValue" . $i, $this->GetCustFieldValue($i));
            }

            return $cStorage->SaveStorageToFile($fileName);
        }
    }
}
?>