<?php

/*  Alternate WebshopEngine
(C) 2009-2014 by Alternate Tools
-----------------------------------------------------

File:         shop_contact.php
Description:  Shop contact

*/
    include "../modules/mod_config.php";
    include "../modules/mod_shop.php";

    // Check for maintenance mode...
    if ($SHOP_MAINTENANCE_MODE == true)
    {
        include $ADMIN_MAINTENANCE_SITE;
        return;
    }

    // Check for login...
    if (check_login() == false && $FORCE_CUSTOMER_LOGIN == true)
    {
        header ("location: " . $SHOP_LOGIN_SITE);
        return;
    }

    include "../modules/class_translation.php";
    include "../modules/class_textfile.php";

    $cFile = new cTextFile;
    $errorMessage = "";

    // Cancel contact
    if (isset($_POST['contact_Cancel']))
    {
        header ('location: ' . $SHOP_MAIN_SITE);
        return;
    }
    // Send contact
    if (isset($_POST['contact_Send']))
    {
        if (isset($_POST['cont_name']) == false || $_POST['cont_name'] == "" ||
            isset($_POST['cont_email']) == false || $_POST['cont_email'] == "" ||
            isset($_POST['cont_message']) == false || $_POST['cont_message'] == "")
        {
            $errorMessage = $cTrans->GetTranslation('shop_contact_error');
        }
        else
        {
			if ($SHOP_CONTACT_SECURITY == "1" && ($_POST['cont_checksum'] != $_POST['cont_checksum_org']))
			{
            	$errorMessage = $cTrans->GetTranslation('shop_contact_errorechecksum');
			}
			else
			{
			    $destEmail = $SHOP_ORDEREMAIL;
                if ($ADMIN_MAILON_CONTACT == true)
                    $destEmail = $destEmail . ', ' . $ADMIN_EMAIL;
                send_mail($destEmail, $SHOP_TITLE . ': ' . $cTrans->GetTranslation('shop_contact_title') . ' - ' . $_POST['cont_name'], $_POST['cont_message'], $_POST['cont_email']);
                header ('location: ' . $SHOP_MAIN_SITE);
			}
        }
    }

    // Display contact page
    $contPage = build_page($SHOP_THEME, false, true, true, "");
    $titleArray = get_shop_navigationtitles();
    $contPage = fill_titles($contPage, $SHOP_TITLE, $titleArray[5]);

    // Error occured?
    if ($errorMessage != "")
        $contPage = build_error_message($errorMessage, $contPage);

    // Main content
    $contMain = build_shop_login();
    $contMain .= $cFile->LoadFromFile($CONTACTTITLE_CONFIG_FILE);
    $contMain .= echo_sr ('<form method="post" action="">');
    $contMain .= echo_sr ('<table class="con_tbl" id="contact_con_tbl">');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_contact_name') . ':</td>');
    if (isset($_POST['cont_name']) == false)
        $_POST['cont_name'] = "";
    $contMain .= echo_sr ('    <td><input type="text" class="cont_name" name="cont_name" size="40" value="' . $_POST['cont_name'] . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_contact_email') . ':</td>');
    if (isset($_POST['cont_email']) == false)
        $_POST['cont_email'] = "";
    $contMain .= echo_sr ('    <td><input type="text" class="cont_email" name="cont_email" size="40" value="' . $_POST['cont_email'] . '"></td>');
    $contMain .= echo_sr ('  </tr>');
    $contMain .= echo_sr ('  <tr>');
    $contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_contact_message') . ':</td>');
    if (isset($_POST['cont_message']) == false)
        $_POST['cont_message'] = "";
    $contMain .= echo_sr ('    <td><textarea class="cont_message" name="cont_message" rows="5" cols="60">' . $_POST['cont_message'] . '</textarea></td>');
    $contMain .= echo_sr ('  </tr>');

	if ($SHOP_CONTACT_SECURITY == "1")  // SPAM protection?
    {
        $checkSum = rand(10000, 99999);
    	$contMain .= echo_sr ('  <tr>');
    	$contMain .= echo_sr ('    <td>' . $cTrans->GetTranslation('shop_contact_checksum') . ': <b>' . $checkSum . '</b></td>');
        $contMain .= echo_sr ('    <td><input type="text" class="cont_checksum" name="cont_checksum" size="5" value=""><input type="hidden" name="cont_checksum_org" value="' . $checkSum . '"></td>');
        $contMain .= echo_sr ('  </tr>');
    }
    $contMain .= echo_sr ('</table>');
    $contMain .= build_shop_bottom_links("contact_Send", $cTrans->GetTranslation('shop_contact_send'), "contact_Cancel", $cTrans->GetTranslation('shop_contact_backtoshop'), false);
    $contMain .= echo_sr ('</form>');

    // Additional content
    $contAdditional = "";

    // Put content together
    $contContent = build_site_content($ALIGN_TOP, $contMain, $contAdditional);
    $contPage = fill_content($contPage, $contContent, "", "");
    $contPage = fill_emptyvars($contPage);

    echo_r($contPage);

?>